/*--------------------------------------------------------------------
This source distribution is placed in the public domain by its author,
Jason Papadopoulos. You may use it for any purpose, free of charge,
without having to notify anyone. I disclaim any responsibility for any
errors, inconsistencies, and inaccuracies with real-world hardware
implementations of the IA64 instruction set. If you build a mission-
critical system based only on this simulator and something goes wrong,
it's your own damned fault.

Optionally, please be nice and tell me if you find this source to be
useful. Again optionally, if you add to the functionality present here
please consider making those additions public too, so that others may 
benefit from your work.	
       				   --jasonp@glue.umd.edu  12/5/99
--------------------------------------------------------------------*/
#ifndef _IA64ASM_H_
#define _IA64ASM_H_

#include "ia64.h"

typedef struct {
   uint32 pred;
   uint32 p[2];
   uint32 b[2];
   uint32 r[3];
   uint64 i[4];
   uint32 f[4];
   uint32 ar[2];
} parse_regs;

typedef struct {
   char format[40];
   uint32 (*asm_func)(uint32 *unit, qword *out);
} lookup;

void decode_instruction( bundle *vliw, uint32 mask, char *dest );
uint32 assemble_instruction(char *input, uint32 *unit, qword *out); 
uint32 bundle_from_file( bundle *vliw, FILE *infile );

#define NUM_LOOKUPS 2125

extern lookup jumptable[];
extern parse_regs op;

#define IUNIT   0x00000001
#define MUNIT   0x00000002
#define FUNIT   0x00000004
#define BUNIT   0x00000008
#define XUNIT1  0x00000010
#define XUNIT2  0x00000020
#define IMUNIT  0x00000040
#define FIRST   0x00000080
#define STOP    0x00000100

#define DRAIN   0x100
#define EMPTY   0x200
#define ERROR   0x400


#define FEW 0
#define MANY 1
#define SPTK 0
#define SPNT 1
#define DPTK 2
#define DPNT 3
#define CLR 1

#endif /* !_IA64ASM_H_ */
